## About

This plugin scans all h2..h6 tags and builds a linked table of contents based on their texts.

## Requirements

- jQuery 1.9+.

## Way of use

	$('body').tableOfContents();
	
## Options
<table>
	<tr>
		<th>Option</th>
		<th>Type</th>
		<th>Default value</th>
	</tr>
	<tr>
		<td>ulClass</td>
		<td>String</td>
		<td>null</td>
	</tr>
	<tr>
		<td>appendAfterSelector</td>
		<td>String</td>
		<td>h1</td>
	</tr>	
</table>

## Examples

The example below will scan all h2..h6 tags inside the body tag and create the corresponding table of contents right after an element matching the #page-title selector. In the example, "table-of-contents" will be the CSS class of the ul element used to build the table of contents.

	$('body').tableOfContents({
		ulClass: 'table-of-contents',
		appendAfterSelector: '#page-title'
	});

Considering the following markup:
	
	<body>
		<h1 id="page-title">Page title</h1>	
		<h2>First h2</h2>
		<p>Some content.</p>
		<h3>First h3</h3>
		<p>Some content.</p>
		<h4>First h4</h4>
		<p>Some content.</p>
		<h5>First h5</h5>
		<p>Some content.</p>
		<h6>First h6</h6>
		<p>Some content.</p>
		<h2>Second h2</h2>
		<p>Some content.</p>
		<h3>First h3</h3>
		<p>Some content.</p>
		<h3>Second h3</h3>
		<p>Some content.</p>
		<h2>Third h2</h2>
		<p>Some content.</p>
	</body>
	
This will be the output generated by the example:

	<body>
	
		<h1 id="page-title">Page title</h1>	
		
		<ul class="table-of-contents">
			<li>
				<a href="#1">First h2</a>
				<ul>
					<li>
						<a href="#2">First h3</a>
						<ul>
							<li>
								<a href="#3">First h4</a>
								<ul>
									<li>
										<a href="#4">First h5</a>
										<ul>
											<li>
												<a href="#5">First h6</a>
											</li>
										</ul>
									</li>
								</ul>
							</li>
						</ul>
					</li>
				</ul>
			</li>
			<li>
				<a href="#6">Second h2</a>
				<ul>
					<li><a href="#7">First h3</a></li>
					<li><a href="#8">Second h3</a></li>
				</ul>
			</li>
			<li>
				<a href="#9">Third h2</a>
			</li>
		</ul>
		
		<a name="1"></a>
		<h2>First h2</h2>
		<p>Some content.</p>
		<a name="2"></a>
		<h3>First h3</h3>
		<p>Some content.</p>
		<a name="3"></a>
		<h4>First h4</h4>
		<p>Some content.</p>
		<a name="4"></a>
		<h5>First h5</h5>
		<p>Some content.</p>
		<a name="5"></a>
		<h6>First h6</h6>
		<p>Some content.</p>
		<a name="6"></a>
		<h2>Second h2</h2>
		<p>Some content.</p>
		<a name="7"></a>
		<h3>First h3</h3>
		<p>Some content.</p>
		<a name="8"></a>
		<h3>Second h3</h3>
		<p>Some content.</p>
		<a name="9"></a>
		<h2>Third h2</h2>
		<p>Some content.</p>

	</body>

Note that the plugin prepends an anchor to every h2..h6 tag and links the items in the table of contents to its corresponding header.
  
