(function($) {

	// Default settings.
	var defaults = {
		ulClass: null,
		appendAfterSelector: 'h1'
	};
	
	var opt = null;
	
	jQuery.fn.tableOfContents = function(options) {
	
		opt = $.extend(true, defaults, options);
		
		var H_MIN = 2;
		var H_MAX = 6;
		
		var h = H_MIN;
		
		var counter = 1;

		var out = '<ul';
		if (opt.ulClass) {
			out += ' class="' + opt.ulClass + '"';
		}
		out += '>';
		
		function buildListItemsAndAnchors(headers, headerNum) {

			if (headerNum > H_MAX) {
				return;
			}
		
			$(headers).each(function() {
				
				var self = $(this);
				
				self.before('<a name="' + counter + '"></a>');

				var hnext = self.nextUntil('h' + headerNum, 'h' + (headerNum + 1));		
				var hnextLength = hnext.size();
				
				out += '<li>';			
				out += '<a class="jqtoc-link" href="#' + counter + '">' + self.text() + '</a>';
				
				counter++;
				
				if (hnextLength) {
					out += '<ul>';
					buildListItemsAndAnchors(hnext, headerNum + 1);
					out += '</ul>';
				}
				out += '</li>';
			});
		}
		
		buildListItemsAndAnchors(this.find('h' + h), h);
		
		out += '</ul>';
		
		var appendAfter = $(opt.appendAfterSelector);
		
		if (appendAfter) {
		
			appendAfter.after($(out));
			
			$('.jqtoc-link').on('click', function(event) {
				var anchor = $(this).attr('href').replace('#', '');
				$('html, body').animate({
					scrollTop: $('a[name=' + anchor + ']').next().offset().top
				}, 'slow');
			});
		
		}
		
		return this;
		
	};
	
}) (jQuery);
